﻿* Encoding: UTF-8.
set seed = 7.
input program.
loop #j = 1 to 30.
   compute id = #j.
   compute xmean = normal(1).
   compute u0j = normal(0.5).
   leave id xmean u0j.

    loop #i = 1 to 30.
       compute xadj = normal(1).
       compute x = xmean + xadj.
       compute y =  xadj - xmean + u0j + normal(1).
     end case.
   end loop.

+ end loop.
+ end file.
end input program.
formats id (f2.0).

* Korrektes Mehrebenenmodell (WB).
MIXED y WITH xmean xadj
  /CRITERIA=DFMETHOD(KENWARDROGER) CIN(95) MXITER(100) MXSTEP(10) SCORING(1) 
    SINGULAR(0.000000000001) HCONVERGE(0, ABSOLUTE) LCONVERGE(0, ABSOLUTE) PCONVERGE(0.000001, ABSOLUTE)    
  /FIXED=xmean xadj | SSTYPE(3)
  /METHOD=REML
  /PRINT=SOLUTION TESTCOV
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* POLS (Pooled Ordinary Least Squares), nur X als Regressor (omitted variable error).
regression dep = y  /enter = x.
GRAPH
  /SCATTERPLOT(BIVAR)=x WITH y
  /MISSING=LISTWISE.

* POLS-Modell mit xmean xadj als Regressoren (fehlerhafter Standardfehler f�r xmean).
regression dep = y  /enter = xmean xadj.

* Effekte in den Klassen.
 * split file by id.
 * regression dep = y  /enter = x.
 * GRAPH
  /SCATTERPLOT(BIVAR)=x WITH y
  /MISSING=LISTWISE.
 * split file off.

* Aggregieren.
DATASET DECLARE SimDatenAgg.
AGGREGATE
  /OUTFILE='SimDatenAgg'
  /BREAK=id
  /x = MEAN(x) /y = MEAN(y).
DATASET Activate SimDatenAgg.

* OLS-Regression mit aggregierten Daten.
regression dep = y  /enter = x.
GRAPH
  /SCATTERPLOT(BIVAR)=x WITH y
  /MISSING=LISTWISE.

