﻿* Encoding: UTF-8.
* Univariate Messwiederholungs-VA per random-intercept - HLM.

set seed = 13.
input program.
+ loop #i = 1 to 30.
compute nr = $casenum.
compute person = normal(3).
compute y1 =       person + normal(3).
compute y2 = 1 + person + normal(3).
compute y3 = 2 + person + normal(3).
-  end case.
+ end loop.
+ end file.
end input program.
formats nr (f2.0).

* Boxplots.
EXAMINE VARIABLES=y1 y2 y3 
  /COMPARE VARIABLE
  /PLOT=BOXPLOT
  /STATISTICS=NONE
  /NOTOTAL
  /MISSING=LISTWISE.

* Messwiderholungs-VA.
GLM y1 y2 y3
  /WSFACTOR=Zeit 3 Polynomial 
  /METHOD=SSTYPE(3)
  /CRITERIA=ALPHA(.05)
  /WSDESIGN=Zeit.

* Breitformat in Langformat wandeln.
VARSTOCASES
  /MAKE y FROM y1 y2 y3
  /INDEX=zeit(2) 
  /KEEP=nr person
  /NULL=KEEP.

* HLM mit random-intercept.
MIXED y BY zeit
  /CRITERIA=CIN(95) MXITER(100) MXSTEP(10) SCORING(1) SINGULAR(0.000000000001) HCONVERGE(0, 
    ABSOLUTE) LCONVERGE(0, ABSOLUTE) PCONVERGE(0.000001, ABSOLUTE)
  /FIXED=zeit | SSTYPE(3)
  /METHOD=REML
  /PRINT=SOLUTION TESTCOV
  /RANDOM=INTERCEPT | SUBJECT(nr) COVTYPE(VC).

* Direkte Spezifikation der R-Matrix (CS).
MIXED y BY zeit
  /CRITERIA=CIN(95) MXITER(100) MXSTEP(10) SCORING(1) SINGULAR(0.000000000001) HCONVERGE(0, 
    ABSOLUTE) LCONVERGE(0, ABSOLUTE) PCONVERGE(0.000001, ABSOLUTE)
  /FIXED=zeit | SSTYPE(3)
  /METHOD=REML
  /PRINT=R SOLUTION TESTCOV
  /REPEATED=zeit | SUBJECT(nr) COVTYPE(CS).

* Direkte Spezifikation der R-Matrix (UN).
MIXED y BY zeit
  /CRITERIA=CIN(95) MXITER(100) MXSTEP(10) SCORING(1) SINGULAR(0.000000000001) HCONVERGE(0, 
    ABSOLUTE) LCONVERGE(0, ABSOLUTE) PCONVERGE(0.000001, ABSOLUTE)
  /FIXED=zeit | SSTYPE(3)
  /METHOD=REML
  /PRINT=R SOLUTION TESTCOV
  /REPEATED=zeit | SUBJECT(nr) COVTYPE(UN).

* p-Level für -2LL - Differenz-Test.
compute p = 1 - CDF.CHISQ(1.081, 4).
execute.

