﻿* Encoding: UTF-8.
set seed = 1.

input program.
loop #j = 1 to 10000.
  compute id = #j.
  leave id.
  compute w = normal(1).
  leave w.
  compute u0j = normal(1).
  leave u0j.
  loop #k = 1 to 5.
     compute x =  normal(1).
     compute y = 1 + 0.3*x + 0.3*w + u0j  + normal(1).
     end case.
  end loop.
end loop.
end file.
end input program.
execute.

formats id (f8.0).

* HLM .
mixed y with x w
 /fixed = x w
 /random intercept | subject(id)
 /print = g solution testcov.


* Probe per Makro und OMS.
DATASET CLOSE MCHLM.
DATASET DECLARE  MCHLM.
OMS
  /SELECT TABLES
  /IF COMMANDS=['Mixed'] SUBTYPES=['Tests of Fixed Effects']
  /DESTINATION FORMAT=SAV NUMBERED=TableNumber_
   OUTFILE='MCHLM' VIEWER=YES.

DEFINE RunSimulations ()
!DO !ind=1 !TO 500

input program.
loop #j = 1 to 103.
  compute id = #j.
  leave id.
  compute w = normal(1).
  leave w.
  compute u0j = normal(1).
  leave u0j.
  loop #k = 1 to 5.
     compute x =  normal(1).
     compute y = 1 + 0.3*x + 0.3*w + u0j  + normal(1).
     end case.
  end loop.
end loop.
end file.
end input program.

* HLM .
mixed y with x w
  /print=solution testcov
  /fixed = x w 
  /random intercept | subject(id).

!DOEND
!ENDDEFINE.

RunSimulations.

OMSEND.

* Auswerten.
DATASET ACTIVATE MCHLM.

* Mikroregressor.
USE ALL.
COMPUTE filter_$=(Var1 = "x").
VARIABLE LABELS filter_$ 'Var1 = "x" (FILTER)'.
VALUE LABELS filter_$ 0 'Not Selected' 1 'Selected'.
FORMATS filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE.

do if (Sig < 0.05).
compute signifikant = 1.
else.
compute signifikant = 0.
end if.
execute.

FREQUENCIES VARIABLES=signifikant
  /ORDER=ANALYSIS.

* Makroregressor.
USE ALL.
COMPUTE filter_$=(Var1 = "w").
VARIABLE LABELS filter_$ 'Var1 = "w" (FILTER)'.
VALUE LABELS filter_$ 0 'Not Selected' 1 'Selected'.
FORMATS filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE.

do if (Sig < 0.05).
compute signifikant = 1.
else.
compute signifikant = 0.
end if.
execute.

FREQUENCIES VARIABLES=signifikant
  /ORDER=ANALYSIS.






