﻿* Encoding: UTF-8.

set seed = 16.
input program.
  loop #i = 1 to 80.
* Natürliche Ursachen.
    compute Z1 = 7 + normal(2).
* Tourismus.
    compute Z2 = 7 + normal(2).
* Brandstiftung.
    compute Z3 = 7 + normal(2).
* Gesamter Einheiteneffekt in Y (inkl. sonstige Ursachen).
    compute Ai = 3 + Z1 + Z2  + Z3 + normal(1).
* Einheiteneffekt in X.
   compute S = normal(4).
    end case.
  end loop.
  end file.
end input program.

* Berechnung von X(i,t) mit einstellbarem Gewicht von (Z1 + Z2).
compute wa = 1.
do repeat X = X1 to X10.
  compute X = 3 + S + wa*(Z1 + Z2) + normal(2).
end repeat.

CORRELATIONS X1 to X10.


do repeat Y = Y1 to Y10 /X = X1 to X10.
  compute Y = 10 + Ai - 0.5*X + normal(4).
end repeat.

compute MX =  mean(X1 to X10).
compute MY =  mean(Y1 to Y10).

* Between-Schätzung des X-Effekts.
REGRESSION
  /DEPENDENT MY
  /METHOD=ENTER MX.

GRAPH
  /SCATTERPLOT(BIVAR)=MX WITH MY
  /MISSING=LISTWISE.

VARSTOCASES
  /ID=id
  /MAKE X FROM X1 to X10
  /MAKE Y FROM Y1 to Y10
  /INDEX=time
  /KEEP=Z1, Z2, Z3, Ai, S, MX, MY
  /NULL=KEEP.

compute DX =  X - MX.

* POLS.
REGRESSION
  /DEPENDENT Y
  /METHOD=ENTER X.

* Spaghetti-Diagramm für 10 Fälle.
USE ALL.
COMPUTE filter_$=(id > 30 & id <= 40).
FILTER BY filter_$.
GRAPH
  /SCATTERPLOT(BIVAR)=X WITH Y BY id
  /MISSING=LISTWISE.
USE ALL.

* Mehrebenenmodell mit unzentriertem Mikroregressor.
MIXED Y WITH X
  /PRINT=SOLUTION TESTCOV
  /FIXED=X | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* Aufnahme von Makroregressor Z1 reduziert den Fehler.
MIXED Y WITH X Z1
  /PRINT=SOLUTION TESTCOV
  /FIXED=X Z1 | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* WB-Modell.
MIXED Y WITH DX MX
  /PRINT=SOLUTION TESTCOV
  /FIXED=DX MX | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* WB-Modell mit Z1, Z2 und Z3.
MIXED Y WITH DX MX Z1 Z2 Z3
  /PRINT=SOLUTION TESTCOV
  /FIXED=DX  MX Z1 Z2 Z3 | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* CRE-Modell mit Z1, Z2 und Z3.
MIXED Y WITH  X MX Z1 Z2 Z3
  /PRINT=SOLUTION TESTCOV
  /FIXED=X MX Z1 Z2 Z3 | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

* Korrektes Mehrebenenmodell mit unzentriertem Mikroregressor.
MIXED Y WITH X Z1 Z2 Z3
  /PRINT=SOLUTION TESTCOV
  /FIXED=X Z1 Z2 Z3 | SSTYPE(3)
  /RANDOM=INTERCEPT | SUBJECT(id) COVTYPE(VC).

